// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// BlobResultDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Blob.h"
#include "BlobResultDlg.h"
#include "BlobDlg.h"
#include <complex>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBlobResultDlg _CAO


CBlobResultDlg::CBlobResultDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlobResultDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlobResultDlg)
	m_blobno = _T("");
	m_result = _T("");
	//}}AFX_DATA_INIT
	// PIݒ
	m_pi = 3.14159265358979; 
	m_lngBlobNo = -1;
}

void CBlobResultDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlobResultDlg)
	DDX_Text(pDX, IDC_BLOBNO, m_blobno);
	DDX_Text(pDX, IDC_RESULT, m_result);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBlobResultDlg, CDialog)
	//{{AFX_MSG_MAP(CBlobResultDlg)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_EXITFORM, OnExitform)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlobResultDlg bZ[W nh

BOOL CBlobResultDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	// SBlobb`
	this->DrawAll();
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

// 
void CBlobResultDlg::OnNext() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );
	
	if( m_lngMaxBlobNo == -1 ) {
		DrawAll();
		return;
	}

    m_lngBlobNo = m_lngBlobNo + 1;

	if ( m_lngBlobNo > m_lngMaxBlobNo ) {
		m_lngBlobNo = m_lngMaxBlobNo;
    }

    DrawOne( m_lngBlobNo );

}
// SBlob`
void CBlobResultDlg::DrawAll()
{
	
	IFvBlobResultGroup2Ptr pBlobResultGroup(__uuidof( FvBlobResultGroup ));
	IFvPointPtr pPoint(__uuidof( FvPoint ));

	m_blobno = "ALL";
	m_result.Format("Su[uF %d" , m_lngMaxBlobNo + 1 );

	// e_CAOʐ
	m_parent->m_FvxDisplayEx->ClearOverlay( -1 ) ;
    m_parent->m_FvxDisplayEx->PutPenColor( 0xFFC0C0 );
	m_parent->m_FvxDisplayEx->DrawData( 0, m_parent->m_ExeRegion );
        
    m_parent->m_FvxDisplayEx->PutPenColor( 0xFF0000 );
    m_parent->m_FvxDisplayEx->PutFontColor( 0x0000FF );
        
    // ʂ̎擾
    m_parent->m_FvxBlob->GetResult( -1 , pBlobResultGroup );
        
    // dS_ƊOڒ``
    m_parent->m_FvxDisplayEx->DrawData( 0, pBlobResultGroup );
        
	CString str;
	for( int i=0 ;i <= m_lngMaxBlobNo ; i++ ){
		// u[uԍԂŕ\
		pPoint->Putx( pBlobResultGroup->Item2(i)->Getcenter_x() );
		pPoint->Puty( pBlobResultGroup->Item2(i)->Getcenter_y() );
		str.Format( "%d" , i );
		m_parent->m_FvxDisplayEx->DrawText( 0, pPoint, _bstr_t( str ));
	}
	UpdateData( FALSE );

}

// I
void CBlobResultDlg::OnExitform() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// _CAOI
	EndDialog( IDOK );

}

// PBlob`
void CBlobResultDlg::DrawOne( int lngNum )
{

	IFvBlobResultPtr pBlobResult(__uuidof( FvBlobResult ));
	IFvLinePtr pLine(__uuidof( FvLine ));
	IFvEllipsePtr pEllipse(__uuidof( FvEllipse ));
	double dblAngle;
	
	m_blobno.Format("%d",lngNum);
	
    // I[o[Cʂ̏
	m_parent->m_FvxDisplayEx->ClearOverlay( -1 ) ;
      
    // ͈͂𔖐ŕ\
    m_parent->m_FvxDisplayEx->PutPenColor( 0xFFC0C0 );
    m_parent->m_FvxDisplayEx->DrawData( 0, m_parent->m_ExeRegion );
    
    // u[uڍ׏擾
    m_parent->m_FvxBlob->GetResult( lngNum, pBlobResult );

	// u[ȕڍׂȏeLXg{bNXɕ\
    m_result.Format("܂܂Ȃʐ : %d\r\n\
 :  %d\r\n\
͒ : %d\r\n\
ȉ~厲 : %.2f\r\n\
ȉ~ : %.2f\r\n\
ȉ~XΊp : %.2f\r\n\
dSW : ( %.2f , %.2f )\r\n\
Xŏl : %d\r\n\
Xől : %d\r\n\
Yŏl : %d\r\n\
Yől : %d\r\n\
܂߂ʐ : %d\r\n\
Oڒ`  : ( %.2f , %.2f )\r\n\
Oڒ` E : ( %.2f , %.2f )\r\n\
Oڒ`  : ( %.2f , %.2f )\r\n\
Oڒ` E : ( %.2f , %.2f )\r\n",
					pBlobResult->Getarea(),
					pBlobResult->Gethole_num(),
					pBlobResult->Getperim(),
					pBlobResult->Getellipse_long(),
					pBlobResult->Getellipse_short(),
					pBlobResult->Getellipse_angle(),
					pBlobResult->Getcenter_x(),
					pBlobResult->Getcenter_y(),
					pBlobResult->Getx_min(),
					pBlobResult->Getx_max(),
					pBlobResult->Gety_min(),
					pBlobResult->Gety_max(),
					pBlobResult->Gettotal_area(),
					pBlobResult->Getbounding_top_x(),
					pBlobResult->Getbounding_top_y(),
					pBlobResult->Getbounding_right_x(),
					pBlobResult->Getbounding_right_y(),
					pBlobResult->Getbounding_left_x(),
					pBlobResult->Getbounding_left_y(),
					pBlobResult->Getbounding_bottom_x(),
					pBlobResult->Getbounding_bottom_y());

    // F = 
    m_parent->m_FvxDisplayEx->PutPenColor( 0xFF0000 );

    // ȉ~
    pEllipse->Putangle( pBlobResult->Getellipse_angle() );
    pEllipse->Putaxis_x( pBlobResult->Getellipse_long() );
    pEllipse->Putaxis_y( pBlobResult->Getellipse_short() );
    pEllipse->Putx( pBlobResult->Getcenter_x() );
    pEllipse->Puty( pBlobResult->Getcenter_y() );
    m_parent->m_FvxDisplayEx->DrawData( 0, pEllipse );

    // dSʂAȉ~̒yђZ̒
    //  dS_: ( x1, y1 )    ȉ~XΊp: ƂƁA̎
    //  - xsin + ycos + ( x1sin - y1cos ) = 0
    dblAngle = pBlobResult->Getellipse_angle() * m_pi / 180;
    pLine->Puta( -sin( dblAngle ) );
    pLine->Putb( cos( dblAngle ) );
    pLine->Putc( (pBlobResult->Getcenter_x() * sin(dblAngle)) - (pBlobResult->Getcenter_y() * cos(dblAngle)) );
    m_parent->m_FvxDisplayEx->DrawData( 0, pLine );

    dblAngle = (pBlobResult->Getellipse_angle() + 90) * m_pi / 180;
    pLine->Puta( -sin(dblAngle) );
    pLine->Putb( cos(dblAngle) );
    pLine->Putc( (pBlobResult->Getcenter_x() * sin(dblAngle)) - (pBlobResult->Getcenter_y() * cos(dblAngle)) );
    m_parent->m_FvxDisplayEx->DrawData( 0, pLine );

    // dS_ƊOڒ`̕`
    m_parent->m_FvxDisplayEx->DrawData( 0, pBlobResult );

	UpdateData( FALSE );

}

// O
void CBlobResultDlg::OnBack() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );
    m_lngBlobNo = m_lngBlobNo - 1;

	if ( m_lngBlobNo < -1 ) {
		m_lngBlobNo = -1;
    }
	if ( m_lngBlobNo == -1 ){
		DrawAll();
	} else {
	    DrawOne( m_lngBlobNo );
	}

}
